// Win32Project1.cpp : Ӧóڵ㡣
//

#include "stdafx.h"
#include "WinFormLibuv.h"
#include <uv.h>
#include <assert.h>
#include <string>
using namespace std;

#pragma comment(lib,"libuv.lib")

#define MAX_LOADSTRING 100

// ȫֱ: 
HINSTANCE hInst;								// ǰʵ
TCHAR szTitle[MAX_LOADSTRING];				// ı
TCHAR szWindowClass[MAX_LOADSTRING];			// 
HWND _hWnd ; 
// ˴ģаĺǰ: 
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
INT_PTR CALLBACK	 WndProc(HWND, UINT, WPARAM, LPARAM);
void SetText(HWND hWnd, WCHAR* content);
int GetTextLength(HWND hWnd);
wstring GetText(HWND hWnd);

int GetTextLength(HWND hWnd){
	int len = SendMessage(hWnd, WM_GETTEXTLENGTH, 0, 0);
	return len ;  
}

wstring GetText(HWND hWnd){
	int len = GetTextLength(hWnd);
	WCHAR* _buffer = new WCHAR[len + 1];  // ˴ȡ 
	SendMessage(hWnd, WM_GETTEXT, (WPARAM)len+1, (LPARAM)_buffer);
	wstring buffer(_buffer) ;  
	delete _buffer ;  
	return buffer;
}  

void SetText(HWND hWnd, wstring content){
	SendMessage(hWnd, WM_SETTEXT, 0, (LPARAM)content.c_str()) ;  
}

int APIENTRY _tWinMain(_In_ HINSTANCE hInstance,
                     _In_opt_ HINSTANCE hPrevInstance,
                     _In_ LPTSTR    lpCmdLine,
                     _In_ int       nCmdShow)
{
	UNREFERENCED_PARAMETER(hPrevInstance);
	UNREFERENCED_PARAMETER(lpCmdLine);

 	// TODO:  ڴ˷ô롣
	MSG msg;
	HACCEL hAccelTable;

	// ʼȫַ
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_WIN32PROJECT1, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	// ִӦóʼ: 
	if (!InitInstance (hInstance, nCmdShow))
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, MAKEINTRESOURCE(IDC_WIN32PROJECT1));

	// Ϣѭ: 
	while (true)
	{
		// uv_run_mode
		uv_run(uv_default_loop(), UV_RUN_NOWAIT);
		if (GetMessage(&msg, NULL, 0, 0)){
			if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg))
			{
				TranslateMessage(&msg);
				DispatchMessage(&msg);
			}
		}
		else
		{
			break ;  
		}
	}

	return (int) msg.wParam;
}

//
//  :  MyRegisterClass()
//
//  Ŀ:  עᴰࡣ
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX);

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	// wcex.lpfnWndProc 	= WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, MAKEINTRESOURCE(IDI_WIN32PROJECT1));
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= MAKEINTRESOURCE(IDC_WIN32PROJECT1);
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, MAKEINTRESOURCE(IDI_SMALL));

	return RegisterClassEx(&wcex);
}

//
//   :  InitInstance(HINSTANCE, int)
//
//   Ŀ:  ʵ
//
//   ע: 
//
//        ڴ˺Уȫֱбʵ
//        ʾ򴰿ڡ
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   HWND hWnd;
   hInst = hInstance; // ʵ洢ȫֱ
   hWnd = CreateDialogParam(hInst, MAKEINTRESOURCE(IDD_ABOUTBOX), NULL, WndProc, NULL);

   if (!hWnd)
   {
      return FALSE;
   }

   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);
  
   return TRUE;
}





uv_tcp_t   _server;
uv_tcp_t   _client;
uv_loop_t* _loop;
static void tinyweb_on_connection(uv_stream_t* server, int status);


void tinyweb_start(uv_loop_t* loop, const char* ip, int port) {
	struct sockaddr_in addr;
	uv_ip4_addr((ip && ip[0]) ? ip : "0.0.0.0", port, &addr);
	_loop = loop;
	uv_tcp_init(_loop, &_server);
	uv_tcp_bind(&_server, (const struct sockaddr*) &addr, 0);
	uv_listen((uv_stream_t*)&_server, 8, tinyweb_on_connection);
}

static void after_uv_close(uv_handle_t* handle) {
	free(handle); // uv_tcp_t* client, see tinyweb_on_connection()  
}

static void after_uv_write(uv_write_t* w, int status) {
	if (w->data)
		free(w->data);
	uv_close((uv_handle_t*)w->handle, after_uv_close); // close client  
	free(w);
}

static void write_uv_data(uv_stream_t* stream, const void* data, unsigned int len, int need_copy_data) {
	uv_buf_t buf;
	uv_write_t* w;
	void* newdata = (void*)data;

	if (data == NULL || len == 0) return;
	if (len == (unsigned int)-1)
		len = strlen((char*)data);

	if (need_copy_data) {
		newdata = malloc(len);
		memcpy(newdata, data, len);
	}

	buf = uv_buf_init((char*)newdata, len);
	w = (uv_write_t*)malloc(sizeof(uv_write_t));
	w->data = need_copy_data ? newdata : NULL;
	uv_write(w, stream, &buf, 1, after_uv_write); // free w and w->data in after_uv_write()  
}

static const char* http_respone = "HTTP/1.1 200 OK\r\n"
"Content-Type:text/html;charset=utf-8\r\n"
"Content-Length:18\r\n"
"\r\n"
"Welcome to tinyweb";

static int r_index = 1; 
static void tinyweb_on_connection(uv_stream_t* server, int status) {
	assert(server == (uv_stream_t*)&_server);
	if (status == 0) {
		uv_tcp_t* client = (uv_tcp_t*)malloc(sizeof(uv_tcp_t));
		uv_tcp_init(_loop, client);
		uv_accept((uv_stream_t*)&_server, (uv_stream_t*)client);
		
		HWND hEdit1Wnd = GetDlgItem(_hWnd, IDC_EDIT1);
		int edit1TextLen = GetTextLength(hEdit1Wnd) ;  
		wstring tmp = GetText(hEdit1Wnd);
		WCHAR _content[1024];
		wsprintf(_content, L"յ%d\r\n", r_index);
		wstring content(_content);
		content.append(tmp)  ;    
		 
		// wsprintf(msg, L"%s\nյ%d",content, r_index);
		SetText(hEdit1Wnd, content) ; 
		// delete content ;
  
		r_index++;
		write_uv_data((uv_stream_t*)client, http_respone, -1, 0);
		//close client after uv_write, and free it in after_uv_close()  
	}
}

// ڡϢ
INT_PTR CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	_hWnd = hWnd;
	UNREFERENCED_PARAMETER(lParam);
	switch (message)
	{
	case WM_INITDIALOG:
		return (INT_PTR)TRUE;

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL)
		{
			EndDialog(hWnd, LOWORD(wParam));
			PostQuitMessage(0) ;  
			return (INT_PTR)TRUE;
		}
		else if (LOWORD(wParam) == IDC_BUTTON1){
			// ::MessageBox(NULL, L"", L"", MB_OK) ;  
			HWND txt_hWnd = GetDlgItem(hWnd, IDC_EDIT1);
			SendMessage(txt_hWnd, WM_SETTEXT, (WPARAM)L"", (LPARAM)L"ʼ\r\n");

			_loop = uv_default_loop() ;  
			tinyweb_start(_loop, "127.0.0.1", 8080);

		}
		break;
	case WM_LBUTTONDOWN:
		break;
	}
	return (INT_PTR)FALSE;
}
